#ifndef WTSOUND_h
#define WTSOUND_h

#include <inttypes.h>

#ifndef WTSOUND_CHANNELS
  #define WTSOUND_CHANNELS 3
#endif
#define WTSOUND_WAVE_TABLE_SIZE 32

class WTSoundClass
{
  public:
    WTSoundClass();
    void begin(uint8_t pin);
    void begin(uint8_t pin, void* bufferPCM, uint16_t bufferPCMSize);
    void setInterval(uint16_t tempo);
    void setInterval(uint16_t tempo, void (* func)());
    void setVelocity(uint8_t ch, int8_t velocity);
    void setProgram(uint8_t ch, uint8_t prog);
    void setWaveTable(uint8_t ch, int8_t* wave);
    void setVelocityPCM(int8_t velocity);
    void play(uint8_t ch, uint8_t note);
    void play(uint8_t ch, uint8_t note, int8_t velocity);
    void playPCM(int8_t* wave, uint16_t size);
    inline void _interval();
  private:
    uint16_t _count[WTSOUND_CHANNELS];
    uint16_t _countadd[WTSOUND_CHANNELS];
    uint8_t _note[WTSOUND_CHANNELS];
    int8_t _velocity[WTSOUND_CHANNELS];
    int8_t _waveTable[WTSOUND_CHANNELS][WTSOUND_WAVE_TABLE_SIZE];
    int8_t _velocityPCM;
    int8_t* _bufferPCM;
    uint16_t _bufferPCMSize;
    volatile uint16_t _bufferPCMHead;
    volatile uint16_t _bufferPCMTail;
    uint16_t _tempo;
    void (*_funcInterval)();
    uint16_t _countInterval;
    uint16_t _countIntervalT;
};
extern WTSoundClass WTSound;

#endif
